local white = Color.new(255,255,255) 
local grey = Color.new(95,95,95) 
local recorded = false
local recording = false
local mic_is_recording = false
local paused = false
local snd = Sound.openWav("app0:/click.wav")

local lastRecord = " "

local delayTouch = 8.0

local btnRec = Graphics.loadImage("app0:/record.png")
local btnStop = Graphics.loadImage("app0:/stop.png")
local btnPlay = Graphics.loadImage("app0:/play.png")
local btnRecs = Graphics.loadImage("app0:/recs.png")
local imgBattery = Graphics.loadImage("app0:/battery.png")

local fnt = Font.load("app0:/font.ttf")
Font.setPixelSizes(fnt, 98)

-- Init a timer
local timer = Timer.new()


local tmpSec = 0
local tmpMilsec = 0

System.createDirectory("ux0:/data/Recordings")

-- Init audio device
Sound.init()

-- Stop Recording
function StartRec()
	Timer.reset(timer)
	Timer.resume(timer)
	tmpSec=0
	tmpMilsec=0
	Mic.start(30, 16000)
	recording = true
end

--Stop Recording
function EndRec()
	Timer.pause(timer)
	day_num, d, mn, y = System.getDate()
	h,m,s = System.getTime()
	Mic.stop("ux0:/data/Recordings/REC_".. d  .. "-" .. mn .. "-" .. y .. "_" .. h .. m .. s ..".wav")
	lastRecord = "ux0:/data/Recordings/REC_".. d  .. "-" .. mn .. "-" .. y .. "_" .. h .. m .. s ..".wav"
	recording = false
	recorded = true
end

-- Main loop
while true do
	
	-- Reading input
	local pad = Controls.read()
	local x1,y1 = Controls.readTouch()
	
	if x1 ~= nil then
		if delayTouch<0.1 then
		-- List button
		if x1>603 and x1<701 and y1>403 then
			if not recording then
			delayTouch=4
			recorded=false
			if Sound.isPlaying(snd) then
				Sound.close(snd)
			end
			lastRecord = " "
			dofile("app0:/list.lua")
			end
		end
		
		-- Play last button
		if x1>259 and x1<357 and y1>403 then
			if not recording and recorded == true then
			delayTouch=4
			if Sound.isPlaying(snd) then
				Sound.close(snd)
			else
			snd = Sound.openWav(lastRecord)
			Sound.play(snd, NO_LOOP)
			end
			end
		end
		
		-- Record/Stop button
		if x1>408 and x1<552 and y1>380 then
			delayTouch=4
			if not recording then
				StartRec()
			else
				EndRec()
			end
				
		end
		end
	end
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	end
	
	if tmpMilsec>99 then
	tmpSec = tmpSec+1
	tmpMilsec=0
	Timer.reset(timer)
	end

		-- Blend instructions
		Graphics.initBlend()
		Screen.clear()
		
		th,tm,ts = System.getTime()
		Graphics.debugPrint(740, 4, string.format("%02d:%02d",th,tm), white)--Draw time

		life = System.getBatteryPercentage()
		
		Graphics.drawImage(912, 4, imgBattery)
		Graphics.fillRect(946, 946-(life/4), 10, 22, white)
		Graphics.debugPrint(850, 4, life .. "%", white)--Draw battery life
	
		Graphics.drawLine(0, 960, 34, 34, white)
		
		if not recording then
			Graphics.debugPrint(5, 4, "Voice Recorder Vita v1.0 by VitaHEX", grey)
			Graphics.drawImage(408, 380, btnRec)
		else
			Graphics.debugPrint(5, 4, "Recording...", white)
			Graphics.drawImage(408, 380, btnStop)
			tmpMilsec=math.ceil(Timer.getTime(timer)/10)
		end
		
		Graphics.fillRect(380, 580, 310, 320, grey)
		Graphics.fillRect(380, 380+(tmpSec*6.62)+(tmpMilsec/20), 310, 320, white)
		
		Font.print(fnt, 360, 180, string.format("%02d:%02d",tmpSec,tmpMilsec), white)
		
		Graphics.debugPrint(240, 340, lastRecord, grey)
		
		Graphics.drawImage(259, 403, btnPlay)
		Graphics.drawImage(603, 403, btnRecs)
		

		Graphics.termBlend()
		
		if delayTouch<0.1 then
		-- Check for input
		if Controls.check(pad, SCE_CTRL_CROSS) then
			delayTouch=4
			-- RECORD
			if not recording then
				StartRec()
			end
		elseif Controls.check(pad, SCE_CTRL_SQUARE) then
			-- STOP
			if recording then
				EndRec()
			end
		elseif Controls.check(pad, SCE_CTRL_TRIANGLE) then
			delayTouch=4
			-- Stopping microphone and go to list
			if recording then
				EndRec()
			end
			dofile("app0:/list.lua")
			break
		end
		end
		
		if recording then
			mic_is_recording = Mic.isRecording()
			if not mic_is_recording then -- Recording time ended
				EndRec()
				if tmpSec==30 and tmpMilsec>0 then
					tmpMilsec=0
				end
			end
		end	
		


	Screen.flip()
	
end