-- Init audio device
Sound.init()
-- Init some colors
local white = Color.new(255, 255, 255)
local yellow = Color.new(255, 255, 0)
local red = Color.new(255, 0, 0)
local grey = Color.new(47, 47, 47)
local oldpad = SCE_CTRL_CROSS

-- List a directory
local scripts = System.listDirectory("ux0:/data/Recordings/")
local cur_dir = "ux0:/data/Recordings/"

local btnBack = Graphics.loadImage("app0:/back.png")
local imgBattery = Graphics.loadImage("app0:/battery.png")
local imgHelp = Graphics.loadImage("app0:/gtop.png")

-- Init a index
local i = 1
local snd = Sound.openWav("app0:/click.wav")
local delayTouch = 8.0


-- Main loop
while true do
	local x1,y1 = Controls.readTouch()
	
	if x1 ~= nil then
		-- Back button
		if x1>870 and y1>460 then
			if Sound.isPlaying(snd) then
				Sound.close(snd)
			end
			Graphics.freeImage(btnBack)
			break
		end
	end
	if delayTouch>0 then 
		delayTouch = delayTouch - 0.1
	end

	Graphics.initBlend()
	Screen.clear()
	Graphics.fillRect(0, 960, 32, 544, grey)
	Graphics.drawImage(250, 5, imgHelp)
	th,tm,ts = System.getTime()
	Graphics.debugPrint(740, 4, string.format("%02d:%02d",th,tm), white)--Draw time
	life = System.getBatteryPercentage()
	Graphics.drawImage(912, 4, imgBattery)
	Graphics.fillRect(946, 946-(life/4), 10, 22, white)
	Graphics.debugPrint(850, 4, life .. "%", white)--Draw battery life
	Graphics.drawLine(0, 960, 34, 34, white)
		
	local y = 36
	-- Write visible menu entries
	for j, file in pairs(scripts) do
		x = 5
		if j >= i and y < 960 then
			if i == j then
				color = red
				x = 10
			else
				color = white
			end
			Graphics.debugPrint(x, y, file.name, color)
			y = y + 20
		end
	end
	
	if #scripts>0 then
	Graphics.debugPrint(5, 4, "Recording " .. i .. "/" .. #scripts, white)
	else
	Graphics.debugPrint(5, 4, "There are no recordings.", red)
	end
	
	Graphics.debugPrint(500, 504, "Voice Recorder Vita v1.0 by VitaHEX\n       www.patreon.com/vitahex", white)
	Graphics.drawImage(882, 473, btnBack)

	Graphics.termBlend()
	
	-- Check for input
	pad = Controls.read()
	if Controls.check(pad, SCE_CTRL_CROSS) and not Controls.check(oldpad, SCE_CTRL_CROSS) then
		if #scripts>0 then
			if Sound.isPlaying(snd) then
				Sound.close(snd)
			end
			snd = Sound.openWav(cur_dir .. scripts[i].name)
			Sound.play(snd, NO_LOOP)
		end
	elseif Controls.check(pad, SCE_CTRL_TRIANGLE) and not Controls.check(oldpad, SCE_CTRL_TRIANGLE) then
		if  delayTouch<0.1 then
			delayTouch=4
			System.deleteFile(cur_dir .. scripts[i].name)
			dofile("app0:/list.lua")
		end
	elseif Controls.check(pad, SCE_CTRL_UP) and not Controls.check(oldpad, SCE_CTRL_UP) then
		if #scripts>0 then
		i = i - 1
		if i < 1 then
			i = #scripts
		end
		end
	elseif Controls.check(pad, SCE_CTRL_DOWN) and not Controls.check(oldpad, SCE_CTRL_DOWN) then
		if #scripts>0 then
		i = i + 1
		if i > #scripts then
			i = 1
		end
		end
	end
	
	-- Check for out of bounds in menu
	if i > #scripts then
		i = 1
	elseif i < 1 then
		i = #scripts
	end
	
	-- Update oldpad and flip screen
	oldpad = pad
	Screen.flip()
	
end
